## picolisp 3.1.9.7

=== debian/changelog ===
picolisp (3.1.9.7-2) unstable; urgency=medium

  * Sync to upstream tip.

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Sat, 07 Feb 2015 18:38:38 +0800

picolisp (3.1.9.7-1) unstable; urgency=medium

  * New upstream release
  * Build *.jar from source
  * Do not install doc/{db,utf8} as requested by upstream

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Fri, 06 Feb 2015 00:19:20 +0800

picolisp (3.1.9.3-1) unstable; urgency=medium

  * New upstream release
  * Upload to unstable

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Tue, 20 Jan 2015 00:29:25 +0800

picolisp (3.1.9.2-1) experimental; urgency=medium

  * New upstream release
  * Refresh patches

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Tue, 06 Jan 2015 23:28:48 +0800

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
DEB_HOST_ARCH_CPU := $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)
DEB_HOST_ARCH_OS  := $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

ifeq (amd64,$(DEB_HOST_ARCH_CPU))
# PIE disabled on amd64 because it's mostly written in assembly and
# already handles PIC when needed. The codes aren't compiled with
# gcc so enable -fPIE is meaningless.
export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie
CFLAGS_NO_PIE := $(shell dpkg-buildflags --get CFLAGS)
LDFLAGS_NO_PIE := $(shell dpkg-buildflags --get LDFLAGS)
endif

LDFLAGS += -Wl,-z,noexecstack

ifeq (arm,$(DEB_HOST_ARCH_CPU))
CFLAGS += -marm
endif

override_dh_auto_build:

	chmod -x app/loc/no

ifeq (amd64,$(DEB_HOST_ARCH_CPU))
	mv src64/tags src64/tags.orig
	make -C src OS=Linux CPU=amd64 picolisp
	make -C src OS=Linux tools gate

	make -C src64 OS=Linux CFLAGS="$(CFLAGS_NO_PIE)" LDFLAGS="$(LDFLAGS_NO_PIE)"
else
	make -C src OS=Linux CPU=$(DEB_HOST_ARCH_CPU) picolisp tools gate
endif
	mkdir -p build/bash_completion.d
	cp lib/bash_completion build/bash_completion.d/pil

	mv java/reflector.jar java/reflector.jar.orig
	(cd java/; ./mkJar)

#       build time utilities
	-rm src64/sysdeps

override_dh_auto_test:
	HOME=$(CURDIR)/build $(CURDIR)/pil test/lib.l -bye + < /dev/null

override_dh_auto_install:

	dh_install build/bash_completion.d/pil etc/bash_completion.d
	dh_install -X.o src   usr/share/picolisp
	dh_install -X.o src64 usr/share/picolisp
	dh_install -X.orig java usr/share/picolisp

override_dh_installdocs:
	dh_installdocs -Xdoc/db -Xdoc/utf8

override_dh_auto_clean:

	make -C src clean
	make -C src64 clean
	-rm bin/ssl bin/httpGate bin/lat1 bin/utf2 bin/balance
	-mv src64/tags.orig src64/tags
	-rm -rf build
	-mv java/reflector.jar.orig java/reflector.jar

override_dh_compress:

	dh_compress -X.l

%:
	dh $@ 

VER?=3.0.7.1
get-orig-source:
	rm -rf picolisp-$(VER).orig
	hg clone https://picolisp.googlecode.com/hg/#v$(VER) picolisp-$(VER).orig
	rm -r picolisp-$(VER).orig/.hg picolisp-$(VER).orig/.hgtags
	GZIP=--best tar -cz --owner root --group root --mode a+rX \
			-f picolisp_$(VER).orig.tar.gz \
			picolisp-$(VER).orig
	rm -r picolisp-$(VER).orig

## picolisp 3.1.11.1

=== debian/changelog ===
picolisp (3.1.11.1-1) unstable; urgency=medium

  * New upstream release; added a missing file svg.l from previous release
  
 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Thu, 25 Jun 2015 12:12:50 -0700

picolisp (3.1.11-1) unstable; urgency=medium

  * New upstream release
  * Install bash completion to usr/share/bash-completion/completions

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Wed, 24 Jun 2015 07:47:24 -0700

picolisp (3.1.10-1) unstable; urgency=medium

  * New upstream release
  * Refresh patches

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Tue, 21 Apr 2015 00:44:55 +0800

=== debian/control ===
Source: picolisp
Section: lisp
Priority: optional
Maintainer: Kan-Ru Chen (陳侃如) <koster@debian.org>
Build-Depends: debhelper (>= 7.0.50~), dpkg-dev (>= 1.16.1~), libssl-dev, gcc-multilib [amd64], lib32gcc1 [amd64], default-jdk
Standards-Version: 3.9.6
Homepage: http://picolisp.com/
Vcs-Git: git://anonscm.debian.org/collab-maint/picolisp.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/picolisp.git;a=summary

# Only supports amd64 on linux and solaris
Package: picolisp
Architecture: kopensolaris-amd64 solaris-amd64 amd64 any-i386 any-arm any-avr32 any-hppa any-m32r any-m68k any-mips any-mipsel any-powerpc any-s390 any-sh3 any-sh3eb any-sh4 any-sh4eb any-sparc
Pre-Depends: dpkg (>= 1.17.5)
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: tinymce
Description: Lisp interpreter and application server framework
 Pico Lisp can be viewed from two different aspects: As a general
 purpose programming language, and a dedicated application server
 framework.
 .
 As a programming language, Pico Lisp provides a 1-to-1 mapping of a
 clean and powerful Lisp derivate, to a simple and efficient virtual
 machine. It supports persistent objects as a first class data type,
 resulting in a database system of Entity/Relation classes and a
 Prolog-like query language tightly integrated into the system.
 .
 As an application server framework, Pico Lisp provides for database
 management (including multi-user synchronization, DB garbage collection
 journalling and replication), web interface integrated (and generated
 from) the application data model, and an application server.

=== debian/rules ===
--- 
+++ 
@@ -51,7 +51,7 @@
 
 override_dh_auto_install:
 
-	dh_install build/bash_completion.d/pil etc/bash_completion.d
+	dh_install build/bash_completion.d/pil usr/share/bash-completion/completions
 	dh_install -X.o src   usr/share/picolisp
 	dh_install -X.o src64 usr/share/picolisp
 	dh_install -X.orig java usr/share/picolisp

## picolisp 15.11

=== src/Makefile ===
# 31mar15abu
# (c) Software Lab. Alexander Burger

bin = ../bin
lib = ../lib

picoFiles = main.c gc.c apply.c flow.c sym.c subr.c big.c io.c net.c tab.c

CC = gcc
# CCLD is the cc (compiler frontend) to use for the link step.
CCLD = gcc

CFLAGS = -c -O2 -pipe \
	-falign-functions=32 -fomit-frame-pointer -fno-strict-aliasing \
	-W -Wimplicit -Wreturn-type -Wunused -Wformat \
	-Wuninitialized -Wstrict-prototypes \
	-D_GNU_SOURCE  -D_FILE_OFFSET_BITS=64


ifeq ($(shell uname), Linux)
	OS = Linux
	CFLAGS += -m32
	PICOLISP-FLAGS = -m32 -rdynamic
	LIB-FLAGS = -lm -ldl
	DYNAMIC-LIB-FLAGS = -m32 -shared -export-dynamic
	LCRYPT = -lcrypt
	STRIP = strip
else
ifeq ($(shell uname), OpenBSD)
	OS = OpenBSD
	CFLAGS += -m32
	PICOLISP-FLAGS = -m32 -rdynamic -Wl,-E
	LIB-FLAGS = -lm
	DYNAMIC-LIB-FLAGS = -Wl,-E -Wl,-shared
	LCRYPT = -lcrypto
	STRIP = strip
else
ifeq ($(shell uname), FreeBSD)
	OS = FreeBSD
	CC = gcc
	CCLD = clang
	CFLAGS += -m32
	PICOLISP-FLAGS = -m32 -rdynamic
	LIB-FLAGS = -lm
	DYNAMIC-LIB-FLAGS = -m32 -shared -export-dynamic
	LCRYPT = -lcrypt
	STRIP = strip
else
ifeq ($(shell uname), NetBSD)
	OS = NetBSD
	CFLAGS += -m32
	PICOLISP-FLAGS = -m32 -rdynamic
	LIB-FLAGS = -lm
	DYNAMIC-LIB-FLAGS = -m32 -shared -export-dynamic
	LCRYPT = -lcrypto
	STRIP = strip
else
ifeq ($(shell uname), Darwin)
	OS = Darwin
	CFLAGS += -m32
	PICOLISP-FLAGS = -m32
	LIB-FLAGS = -lc -lm -ldl
	DYNAMIC-LIB-FLAGS = -m32 -dynamiclib -undefined dynamic_lookup
	LCRYPT = -lcrypto
	STRIP = strip -x
else
ifeq ($(shell uname), SunOS)
	OS = SunOS
	CFLAGS += -m32
	PICOLISP-FLAGS =
	LIB-FLAGS = -lm -lnsl -lsocket
	DYNAMIC-LIB-FLAGS = -G
	LCRYPT = -lcrypt
	STRIP = strip
else
ifeq ($(shell uname), AIX)
	OS = AIX
	CFLAGS += -maix32
	PICOLISP-FLAGS = -maix32 -Wl,-brtl -Wl,-bexpall
	LIB-FLAGS = -lm
	DYNAMIC-LIB-FLAGS = -maix32 -Wl,-G -shared -lm
	LCRYPT = -lcrypt
	STRIP = strip
else
ifeq ($(shell uname), HP-UX)
	OS = HP-UX
	CFLAGS +=
	PICOLISP-FLAGS = -m32 -rdynamic
	LIB-FLAGS = -lm -ldl
	DYNAMIC-LIB-FLAGS = -m32 -shared
	LCRYPT =
	STRIP = strip
else
ifeq ($(shell uname -o), Cygwin)
	OS = Cygwin
	CFLAGS += -m32
	DYNAMIC-LIB-FLAGS = -shared
	PICOLISP-FLAGS =
	DLL-DEFS = $(bin)/picolisp.dll
	LCRYPT = -lcrypt
	STRIP = strip
	exe = .exe
	dll = .dll
endif
endif
endif
endif
endif
endif
endif
endif
endif


picolisp: $(bin)/picolisp $(lib)/ext$(dll) $(lib)/ht$(dll)
tools: $(bin)/lat1 $(bin)/utf2 $(bin)/balance
gate: $(bin)/ssl $(bin)/httpGate

all: picolisp tools gate

.c.o:
	$(CC) $(CFLAGS) -D_OS='"$(OS)"' $*.c


$(picoFiles:.c=.o) ext.o ht.o: pico.h
main.o: vers.h


ifeq ($(OS), Cygwin)

$(bin)/picolisp$(dll): $(picoFiles:.c=.o)
	$(CCLD) -o $(bin)/picolisp$(dll) $(DYNAMIC-LIB-FLAGS) $(picoFiles:.c=.o)
	$(STRIP) $(bin)/picolisp$(dll)

$(bin)/picolisp: $(picoFiles:.c=.o) $(bin)/picolisp$(dll) start.o
	mkdir -p $(bin) $(lib)
	$(CCLD) -o $(bin)/picolisp$(exe) $(PICOLISP-FLAGS) start.o -L$(bin) -l$(bin)/picolisp
	$(STRIP) $(bin)/picolisp$(exe)

else

$(bin)/picolisp: $(picoFiles:.c=.o)
	mkdir -p $(bin) $(lib)
	$(CCLD) -o $(bin)/picolisp$(exe) $(PICOLISP-FLAGS) $(picoFiles:.c=.o) $(LIB-FLAGS)
	$(STRIP) $(bin)/picolisp$(exe)

endif


$(lib)/ext$(dll): ext.o
	$(CCLD) -o $(lib)/ext$(dll) $(DYNAMIC-LIB-FLAGS) ext.o $(DLL-DEFS) $(LCRYPT)
	$(STRIP) $(lib)/ext$(dll)

$(lib)/ht$(dll): ht.o
	$(CCLD) -o $(lib)/ht$(dll) $(DYNAMIC-LIB-FLAGS) ht.o $(DLL-DEFS)
	$(STRIP) $(lib)/ht$(dll)


$(bin)/lat1: lat1.c
	$(CC) -o $(bin)/lat1$(exe) lat1.c
	$(STRIP) $(bin)/lat1$(exe)

$(bin)/utf2: utf2.c
	$(CC) -o $(bin)/utf2$(exe) utf2.c
	$(STRIP) $(bin)/utf2$(exe)

$(bin)/balance: balance.c
	$(CC) -o $(bin)/balance$(exe) balance.c
	$(STRIP) $(bin)/balance$(exe)

$(bin)/ssl: ssl.c
	$(CC) -o $(bin)/ssl$(exe) ssl.c -lssl -lcrypto
	$(STRIP) $(bin)/ssl$(exe)

$(bin)/httpGate: httpGate.c
	$(CC) -o $(bin)/httpGate$(exe) httpGate.c -lssl -lcrypto
	$(STRIP) $(bin)/httpGate$(exe)


# Clean up
clean:
	rm -f *.o

# vi:noet:ts=4:sw=4

=== src64/Makefile ===
# 16nov15abu
# (c) Software Lab. Alexander Burger

bin = ../bin
lib = ../lib

ifeq ($(MAKECMDGOALS), arm64.linux)
	UNAME = Linux
	MACHINE = arm64
else
	ifeq ($(MAKECMDGOALS), x86-64.linux)
		UNAME = Linux
		MACHINE = x86_64
	else
		ifeq ($(MAKECMDGOALS), ppc64.linux)
			UNAME = Linux
			MACHINE = ppc64le
		else
			ifeq ($(MAKECMDGOALS), x86-64.freeBsd)
				UNAME = FreeBSD
				MACHINE = x86_64
			else
				ifeq ($(MAKECMDGOALS), x86-64.sunOs)
					UNAME = SunOS
					MACHINE = x86_64
				else
					UNAME = $(shell uname)
					ifeq ($(MAKECMDGOALS), emu)
						MACHINE = emu
					else
						MACHINE = $(shell uname -m)
					endif
				endif
			endif
		endif
	endif
endif

SYS =
FMT = .c
ARCH = emu
STRIP = :

ifeq ($(UNAME), Linux)
	OS = Linux
	ifeq ($(MACHINE), arm64)
		SYS = .linux
		FMT = .s
		ARCH = arm64
		AS = as
	else
		ifeq ($(MACHINE), x86_64)
			SYS = .linux
			FMT = .s
			ARCH = x86-64
			AS = as
		else
			ifeq ($(MACHINE), ppc64le)
				SYS = .linux
				FMT = .s
				ARCH = ppc64
				AS = as -mppc64 -a64 -mlittle
			endif
		endif
	endif
	LD-MAIN = -Wl,--no-as-needed -rdynamic -lc -lm -ldl
	LD-SHARED = -shared -export-dynamic
	STRIP = strip
else
	ifeq ($(UNAME), FreeBSD)
		OS = FreeBSD
		SYS = .freeBsd
		FMT = .s
		ARCH = x86-64
		AS = as
		LD-MAIN = -Wl,--no-as-needed -rdynamic -lc -lm
		LD-SHARED = -shared -rdynamic
		STRIP = strip
	else
		ifeq ($(UNAME), SunOS)
			OS = SunOS
			SYS = .sunOs
			FMT = .s
			ARCH = x86-64
			AS = gas --64
			LD-MAIN = -m64 -lc -lm -ldl -lsocket -lnsl
			LD-SHARED = -m64 -shared
			STRIP = strip
		endif
	endif
endif

baseFiles = version.l glob.l main.l \
	gc.l apply.l flow.l sym.l subr.l big.l io.l db.l net.l err.l

sFiles = \
	$(ARCH)$(SYS).base$(FMT) \
	$(ARCH)$(SYS).ext$(FMT) \
	$(ARCH)$(SYS).ht$(FMT)

all: picolisp

arm64.linux: $(sFiles)
x86-64.linux: $(sFiles)
ppc64.linux: $(sFiles)
x86-64.freeBsd: $(sFiles)
x86-64.sunOs: $(sFiles)
emu: picolisp

picolisp: $(bin)/picolisp $(lib)/ext $(lib)/ht

### Link ###
$(bin)/picolisp: $(ARCH)$(SYS).base.o
	$(CC) -o $(bin)/picolisp $(ARCH)$(SYS).base.o $(LD-MAIN)
	$(STRIP) $(bin)/picolisp

$(lib)/ext: $(ARCH)$(SYS).ext.o
	$(CC) -o $(lib)/ext $(ARCH)$(SYS).ext.o $(LD-SHARED)
	$(STRIP) $(lib)/ext

$(lib)/ht: $(ARCH)$(SYS).ht.o
	$(CC) -o $(lib)/ht $(ARCH)$(SYS).ht.o $(LD-SHARED)
	$(STRIP) $(lib)/ht

### Assemble ###
.s.o:
	$(AS) -o $*.o $*.s

### Compile ###
sysdefs: sysdefs.c
	$(CC) -o sysdefs -D_FILE_OFFSET_BITS=64 sysdefs.c
	$(STRIP) sysdefs

emu.base.o: sysdefs emu.base.c
	$(CC) -c -O -fomit-frame-pointer -D_FILE_OFFSET_BITS=64 emu.base.c

.c.o:
	$(CC) -c -O -fpic -fomit-frame-pointer -D_FILE_OFFSET_BITS=64 $*.c

### Translate ###
$(ARCH)$(SYS).base$(FMT): arch/$(ARCH).l defs.l $(baseFiles) sys/$(ARCH)$(SYS).code.l
	./mkAsm $(ARCH) "$(SYS)" $(FMT) $(OS) base "" $(lib)/map  $(baseFiles) sys/$(ARCH)$(SYS).code.l

$(ARCH)$(SYS).ext$(FMT): arch/$(ARCH).l defs.l ext.l $(ARCH)$(SYS).base$(FMT)
	./mkAsm $(ARCH) "$(SYS)" $(FMT) $(OS) ext T ""  ext.l

$(ARCH)$(SYS).ht$(FMT): arch/$(ARCH).l defs.l ht.l $(ARCH)$(SYS).base$(FMT)
	./mkAsm $(ARCH) "$(SYS)" $(FMT) $(OS) ht T ""  ht.l

### Clean up ###
clean:
	rm -f emu.*.c *.s *.o *.symtab sysdefs

# vi:noet:ts=4:sw=4

=== debian/changelog ===
picolisp (15.11-1) unstable; urgency=medium

  * New upstream release
  * Refresh patches
  * debian/patches/0004-picolisp_reproducible_build.patch:
    Make amd64 build reproducible
  * Fix FTBFS on hurd-i386. Thanks Svante Signell for the patch.
    (Closes: 802602)
  * Build x86_64 and ppc64el with ersatz.
    Remove dependency of gcc-multilib.

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Wed, 16 Dec 2015 00:19:17 +0800

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: lisp
 Priority: optional
 Maintainer: Kan-Ru Chen (陳侃如) <koster@debian.org>
-Build-Depends: debhelper (>= 7.0.50~), dpkg-dev (>= 1.16.1~), libssl-dev, gcc-multilib [amd64], lib32gcc1 [amd64], default-jdk
+Build-Depends: debhelper (>= 7.0.50~), dpkg-dev (>= 1.16.1~), libssl-dev, default-jdk
 Standards-Version: 3.9.6
 Homepage: http://picolisp.com/
 Vcs-Git: git://anonscm.debian.org/collab-maint/picolisp.git
@@ -10,7 +10,7 @@
 
 # Only supports amd64 on linux and solaris
 Package: picolisp
-Architecture: kopensolaris-amd64 solaris-amd64 amd64 any-i386 any-arm any-avr32 any-hppa any-m32r any-m68k any-mips any-mipsel any-powerpc any-s390 any-sh3 any-sh3eb any-sh4 any-sh4eb any-sparc
+Architecture: kopensolaris-amd64 solaris-amd64 amd64 any-i386 any-arm any-avr32 any-hppa any-m32r any-m68k any-mips any-mipsel any-powerpc any-s390 any-sh3 any-sh3eb any-sh4 any-sh4eb any-sparc any-ppc64el
 Pre-Depends: dpkg (>= 1.17.5)
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Suggests: tinymce

=== debian/rules ===
--- 
+++ 
@@ -28,20 +28,24 @@
 
 	chmod -x app/loc/no
 
+	mv java/reflector.jar java/reflector.jar.orig
+	(cd java/; ./mkJar)
+
 ifeq (amd64,$(DEB_HOST_ARCH_CPU))
 	mv src64/tags src64/tags.orig
-	make -C src OS=Linux CPU=amd64 picolisp
 	make -C src OS=Linux tools gate
 
-	make -C src64 OS=Linux CFLAGS="$(CFLAGS_NO_PIE)" LDFLAGS="$(LDFLAGS_NO_PIE)"
+	make -C src64 OS=Linux CFLAGS="$(CFLAGS_NO_PIE)" LDFLAGS="$(LDFLAGS_NO_PIE)" x86-64.linux picolisp
+else ifeq (ppc64el,$(DEB_HOST_ARCH_CPU))
+	mv src64/tags src64/tags.orig
+	make -C src OS=Linux tools gate
+
+	make -C src64 CFLAGS="$(CFLAGS_NO_PIE)" LDFLAGS="$(LDFLAGS_NO_PIE)" ppc64.linux picolisp
 else
 	make -C src OS=Linux CPU=$(DEB_HOST_ARCH_CPU) picolisp tools gate
 endif
 	mkdir -p build/bash_completion.d
 	cp lib/bash_completion build/bash_completion.d/pil
-
-	mv java/reflector.jar java/reflector.jar.orig
-	(cd java/; ./mkJar)
 
 #       build time utilities
 	-rm src64/sysdeps

## picolisp 16.2

=== src/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# 31mar15abu
+# 02feb16abu
 # (c) Software Lab. Alexander Burger
 
 bin = ../bin
@@ -91,6 +91,12 @@
 	LCRYPT =
 	STRIP = strip
 else
+ifeq ($(shell uname), IRIX64)
+    OS = IRIX64
+    CFLAGS += -std=gnu99
+    DYNAMIC-LIB-FLAGS = -shared
+    STRIP = strip -f
+else
 ifeq ($(shell uname -o), Cygwin)
 	OS = Cygwin
 	CFLAGS += -m32
@@ -101,6 +107,7 @@
 	STRIP = strip
 	exe = .exe
 	dll = .dll
+endif
 endif
 endif
 endif

=== debian/changelog ===
picolisp (16.2-2) unstable; urgency=medium

  * Fix lib/ext loading problem on pil32.
  * Import upstream minor version update and a fix to pil64.
  * Bump Standards-Version to 3.9.7, no changes needed

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Mon, 22 Feb 2016 01:54:15 +0800

picolisp (16.2-1) unstable; urgency=medium

  [ Kan-Ru Chen (陳侃如) ]
  * New upstream release
  * Fix minimum java bytecode version used by mkJar
  * Install correct upstream changelog file
  * Do not generate incorrect dbgsym package

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Sat, 20 Feb 2016 17:42:27 +0800

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Kan-Ru Chen (陳侃如) <koster@debian.org>
 Build-Depends: debhelper (>= 7.0.50~), dpkg-dev (>= 1.16.1~), libssl-dev, default-jdk
-Standards-Version: 3.9.6
+Standards-Version: 3.9.7
 Homepage: http://picolisp.com/
 Vcs-Git: git://anonscm.debian.org/collab-maint/picolisp.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/picolisp.git;a=summary

## picolisp 16.12

=== src64/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# 16nov15abu
+# 05dec16abu
 # (c) Software Lab. Alexander Burger
 
 bin = ../bin
@@ -20,15 +20,20 @@
 				UNAME = FreeBSD
 				MACHINE = x86_64
 			else
-				ifeq ($(MAKECMDGOALS), x86-64.sunOs)
-					UNAME = SunOS
+				ifeq ($(MAKECMDGOALS), x86-64.openBsd)
+					UNAME = OpenBSD
 					MACHINE = x86_64
 				else
-					UNAME = $(shell uname)
-					ifeq ($(MAKECMDGOALS), emu)
-						MACHINE = emu
+					ifeq ($(MAKECMDGOALS), x86-64.sunOs)
+						UNAME = SunOS
+						MACHINE = x86_64
 					else
-						MACHINE = $(shell uname -m)
+						UNAME = $(shell uname)
+						ifeq ($(MAKECMDGOALS), emu)
+							MACHINE = emu
+						else
+							MACHINE = $(shell uname -m)
+						endif
 					endif
 				endif
 			endif
@@ -37,6 +42,7 @@
 endif
 
 SYS =
+PIE =
 FMT = .c
 ARCH = emu
 STRIP = :
@@ -53,6 +59,7 @@
 			SYS = .linux
 			FMT = .s
 			ARCH = x86-64
+			## PIE = -no-pie
 			AS = as
 		else
 			ifeq ($(MACHINE), ppc64le)
@@ -77,15 +84,26 @@
 		LD-SHARED = -shared -rdynamic
 		STRIP = strip
 	else
-		ifeq ($(UNAME), SunOS)
-			OS = SunOS
-			SYS = .sunOs
+		ifeq ($(UNAME), OpenBSD)
+			OS = OpenBSD
+			SYS = .openBsd
 			FMT = .s
 			ARCH = x86-64
-			AS = gas --64
-			LD-MAIN = -m64 -lc -lm -ldl -lsocket -lnsl
-			LD-SHARED = -m64 -shared
+			AS = as
+			LD-MAIN = -Wl,-nopie -rdynamic -lc -lm
+			LD-SHARED = -shared -rdynamic
 			STRIP = strip
+		else
+			ifeq ($(UNAME), SunOS)
+				OS = SunOS
+				SYS = .sunOs
+				FMT = .s
+				ARCH = x86-64
+				AS = gas --64
+				LD-MAIN = -m64 -lc -lm -ldl -lsocket -lnsl
+				LD-SHARED = -m64 -shared
+				STRIP = strip
+			endif
 		endif
 	endif
 endif
@@ -104,6 +122,7 @@
 x86-64.linux: $(sFiles)
 ppc64.linux: $(sFiles)
 x86-64.freeBsd: $(sFiles)
+x86-64.openBsd: $(sFiles)
 x86-64.sunOs: $(sFiles)
 emu: picolisp
 
@@ -111,7 +130,7 @@
 
 ### Link ###
 $(bin)/picolisp: $(ARCH)$(SYS).base.o
-	$(CC) -o $(bin)/picolisp $(ARCH)$(SYS).base.o $(LD-MAIN)
+	$(CC) -o $(bin)/picolisp $(ARCH)$(SYS).base.o $(LD-MAIN) $(PIE)
 	$(STRIP) $(bin)/picolisp
 
 $(lib)/ext: $(ARCH)$(SYS).ext.o

=== debian/changelog ===
picolisp (16.12-1) unstable; urgency=medium

  * New upstream version 16.12

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Sat, 10 Dec 2016 21:31:05 -1000

picolisp (16.11.6-1) unstable; urgency=medium

  * New upstream version 16.11.6
  * debian/compat: Change dh compatibility to 9
  * Require dpkg-dev >= 1.18.11 to build without PIE enabled. (Closes: #837573)

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Wed, 09 Nov 2016 09:08:14 +0800

picolisp (16.6-2) unstable; urgency=medium

  * Import upstream changes.
    - Closes: #831397

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Sun, 17 Jul 2016 22:59:31 +0800

picolisp (16.6-1) unstable; urgency=medium

  * New upstream release.
  * Update minimum java bytecode version used by mkJar to Java7.
  * Bump Standards-Version to 3.9.8, no changes needed.

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Mon, 04 Jul 2016 23:32:05 +0800

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: lisp
 Priority: optional
 Maintainer: Kan-Ru Chen (陳侃如) <koster@debian.org>
-Build-Depends: debhelper (>= 7.0.50~), dpkg-dev (>= 1.16.1~), libssl-dev, default-jdk
-Standards-Version: 3.9.7
+Build-Depends: debhelper (>= 7.0.50~), dpkg-dev (>= 1.18.11~), libssl-dev, default-jdk
+Standards-Version: 3.9.8
 Homepage: http://picolisp.com/
 Vcs-Git: git://anonscm.debian.org/collab-maint/picolisp.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/picolisp.git;a=summary

=== debian/rules ===
--- 
+++ 
@@ -63,6 +63,9 @@
 override_dh_installdocs:
 	dh_installdocs -Xdoc/db -Xdoc/utf8
 
+override_dh_installchangelogs:
+	dh_installchangelogs -k -XChangeLog CHANGES
+
 override_dh_auto_clean:
 
 	make -C src clean
@@ -76,6 +79,9 @@
 
 	dh_compress -X.l
 
+override_dh_strip:
+	dh_strip --no-automatic-dbgsym
+
 %:
 	dh $@

## picolisp 17.6

=== src64/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# 05dec16abu
+# 28mar17abu
 # (c) Software Lab. Alexander Burger
 
 bin = ../bin
@@ -59,7 +59,9 @@
 			SYS = .linux
 			FMT = .s
 			ARCH = x86-64
-			## PIE = -no-pie
+			ifeq ($(shell gcc -dumpspecs | grep -q no-pie ; echo $$?), 0)
+				PIE = -no-pie
+			endif
 			AS = as
 		else
 			ifeq ($(MACHINE), ppc64le)

=== debian/changelog ===
picolisp (17.6-1) unstable; urgency=medium

  * New upstream version 17.6
  * Refresh patches
  * debian/control: Bump Standards-Version to 4.0.0.
    Updated copyright-format url. No other changes needed.

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Wed, 12 Jul 2017 07:15:16 +0800

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Kan-Ru Chen (陳侃如) <koster@debian.org>
 Build-Depends: debhelper (>= 7.0.50~), dpkg-dev (>= 1.18.11~), libssl-dev, default-jdk
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Homepage: http://picolisp.com/
 Vcs-Git: git://anonscm.debian.org/collab-maint/picolisp.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/picolisp.git;a=summary

## picolisp 17.12%2B20180218

=== src64/Makefile ===
# 31oct17abu
# (c) Software Lab. Alexander Burger

bin = ../bin
lib = ../lib

ifeq ($(MAKECMDGOALS), arm64.android)
	UNAME = Android
	MACHINE = aarch64
else
	ifeq ($(MAKECMDGOALS), arm64.linux)
		UNAME = Linux
		MACHINE = aarch64
	else
		ifeq ($(MAKECMDGOALS), x86-64.linux)
			UNAME = Linux
			MACHINE = x86_64
		else
			ifeq ($(MAKECMDGOALS), ppc64.linux)
				UNAME = Linux
				MACHINE = ppc64le
			else
				ifeq ($(MAKECMDGOALS), x86-64.freeBsd)
					UNAME = FreeBSD
					MACHINE = x86_64
				else
					ifeq ($(MAKECMDGOALS), x86-64.openBsd)
						UNAME = OpenBSD
						MACHINE = x86_64
					else
						ifeq ($(MAKECMDGOALS), x86-64.sunOs)
							UNAME = SunOS
							MACHINE = x86_64
						else
							UNAME = $(shell uname)
							ifeq ($(MAKECMDGOALS), emu)
								MACHINE = emu
							else
								MACHINE = $(shell uname -m)
							endif
						endif
					endif
				endif
			endif
		endif
	endif
endif

SYS =
PIE =
FMT = .c
ARCH = emu
STRIP = :

ifeq ($(UNAME), Android)
	OS = Android
	SYS = .android
	ifeq ($(MACHINE), aarch64)
		FMT = .s
		ARCH = arm64
		AS = as
	endif
else
	ifeq ($(UNAME), Linux)
		OS = Linux
		ifeq ($(MACHINE), aarch64)
			SYS = .linux
			FMT = .s
			ARCH = arm64
			AS = as
		else
			ifeq ($(MACHINE), x86_64)
				SYS = .linux
				FMT = .s
				ARCH = x86-64
				ifeq ($(shell gcc -dumpspecs | grep -q no-pie ; echo $$?), 0)
					PIE = -no-pie
				endif
				AS = as
			else
				ifeq ($(MACHINE), ppc64le)
					SYS = .linux
					FMT = .s
					ARCH = ppc64
					AS = as -mppc64 -a64 -mlittle
				endif
			endif
		endif
		LD-MAIN = -Wl,--no-as-needed -rdynamic -lc -lm -ldl
		LD-SHARED = -shared -export-dynamic
		STRIP = strip
	else
		ifeq ($(UNAME), FreeBSD)
			OS = FreeBSD
			SYS = .freeBsd
			FMT = .s
			ARCH = x86-64
			AS = as
			LD-MAIN = -Wl,--no-as-needed -rdynamic -lc -lm
			LD-SHARED = -shared -rdynamic
			STRIP = strip
		else
			ifeq ($(UNAME), OpenBSD)
				OS = OpenBSD
				SYS = .openBsd
				FMT = .s
				ARCH = x86-64
				AS = as
				LD-MAIN = -Wl,-nopie -rdynamic -lc -lm
				LD-SHARED = -shared -rdynamic
				STRIP = strip
			else
				ifeq ($(UNAME), SunOS)
					OS = SunOS
					SYS = .sunOs
					FMT = .s
					ARCH = x86-64
					AS = gas --64
					LD-MAIN = -m64 -lc -lm -ldl -lsocket -lnsl
					LD-SHARED = -m64 -shared
					STRIP = strip
				endif
			endif
		endif
	endif
endif

baseFiles = version.l glob.l main.l \
	gc.l apply.l flow.l sym.l subr.l big.l io.l db.l net.l err.l

sFiles = \
	$(ARCH)$(SYS).base$(FMT) \
	$(ARCH)$(SYS).ext$(FMT) \
	$(ARCH)$(SYS).ht$(FMT)

all: picolisp

arm64.android: $(sFiles)
arm64.linux: $(sFiles)
x86-64.linux: $(sFiles)
ppc64.linux: $(sFiles)
x86-64.freeBsd: $(sFiles)
x86-64.openBsd: $(sFiles)
x86-64.sunOs: $(sFiles)
emu: picolisp

picolisp: $(bin)/picolisp $(lib)/ext $(lib)/ht

### Link ###
$(bin)/picolisp: $(ARCH)$(SYS).base.o
	$(CC) -o $(bin)/picolisp $(ARCH)$(SYS).base.o $(LD-MAIN) $(PIE)
	$(STRIP) $(bin)/picolisp

$(lib)/ext: $(ARCH)$(SYS).ext.o
	$(CC) -o $(lib)/ext $(ARCH)$(SYS).ext.o $(LD-SHARED)
	$(STRIP) $(lib)/ext

$(lib)/ht: $(ARCH)$(SYS).ht.o
	$(CC) -o $(lib)/ht $(ARCH)$(SYS).ht.o $(LD-SHARED)
	$(STRIP) $(lib)/ht

### Assemble ###
.s.o:
	$(AS) -o $*.o $*.s

### Compile ###
sysdefs: sysdefs.c
	$(CC) -o sysdefs -D_FILE_OFFSET_BITS=64 sysdefs.c
	$(STRIP) sysdefs

emu.base.o: sysdefs emu.base.c
	$(CC) -c -O -fomit-frame-pointer -D_FILE_OFFSET_BITS=64 emu.base.c

.c.o:
	$(CC) -c -O -fpic -fomit-frame-pointer -D_FILE_OFFSET_BITS=64 $*.c

### Translate ###
$(ARCH)$(SYS).base$(FMT): arch/$(ARCH).l defs.l $(baseFiles) sys/$(ARCH)$(SYS).code.l
	./mkAsm $(ARCH) "$(SYS)" $(FMT) $(OS) base "" $(lib)/map  $(baseFiles) sys/$(ARCH)$(SYS).code.l

$(ARCH)$(SYS).ext$(FMT): arch/$(ARCH).l defs.l ext.l $(ARCH)$(SYS).base$(FMT)
	./mkAsm $(ARCH) "$(SYS)" $(FMT) $(OS) ext T ""  ext.l

$(ARCH)$(SYS).ht$(FMT): arch/$(ARCH).l defs.l ht.l $(ARCH)$(SYS).base$(FMT)
	./mkAsm $(ARCH) "$(SYS)" $(FMT) $(OS) ht T ""  ht.l

### Clean up ###
clean:
	rm -f emu.*.c *.s *.o *.symtab sysdefs

# vi:noet:ts=4:sw=4

=== debian/control ===
--- 
+++ 
@@ -2,15 +2,15 @@
 Section: lisp
 Priority: optional
 Maintainer: Kan-Ru Chen (陳侃如) <koster@debian.org>
-Build-Depends: debhelper (>= 7.0.50~), dpkg-dev (>= 1.18.11~), libssl-dev, default-jdk
-Standards-Version: 4.0.0
+Build-Depends: debhelper (>= 11), dpkg-dev (>= 1.18.11~), libssl-dev, default-jdk
+Standards-Version: 4.1.3
 Homepage: http://picolisp.com/
-Vcs-Git: git://anonscm.debian.org/collab-maint/picolisp.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/picolisp.git;a=summary
+Vcs-Git: https://salsa.debian.org/koster/picolisp.git
+Vcs-Browser: https://salsa.debian.org/koster/picolisp
 
 # Only supports amd64 on linux and solaris
 Package: picolisp
-Architecture: kopensolaris-amd64 solaris-amd64 amd64 any-i386 any-arm any-avr32 any-hppa any-m32r any-m68k any-mips any-mipsel any-powerpc any-s390 any-sh3 any-sh3eb any-sh4 any-sh4eb any-sparc any-ppc64el
+Architecture: any
 Pre-Depends: dpkg (>= 1.17.5)
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Suggests: tinymce

## picolisp 17.12+20180218

=== src/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# 02feb16abu
+# 04oct17abu
 # (c) Software Lab. Alexander Burger
 
 bin = ../bin
@@ -10,26 +10,29 @@
 # CCLD is the cc (compiler frontend) to use for the link step.
 CCLD = gcc
 
+M32=-m32
+
 CFLAGS = -c -O2 -pipe \
 	-falign-functions=32 -fomit-frame-pointer -fno-strict-aliasing \
 	-W -Wimplicit -Wreturn-type -Wunused -Wformat \
 	-Wuninitialized -Wstrict-prototypes \
 	-D_GNU_SOURCE  -D_FILE_OFFSET_BITS=64
 
+DYNAMIC-CC-FLAGS=
 
 ifeq ($(shell uname), Linux)
 	OS = Linux
-	CFLAGS += -m32
-	PICOLISP-FLAGS = -m32 -rdynamic
+	CFLAGS += ${M32}
+	PICOLISP-FLAGS = ${M32} -rdynamic
 	LIB-FLAGS = -lm -ldl
-	DYNAMIC-LIB-FLAGS = -m32 -shared -export-dynamic
+	DYNAMIC-LIB-FLAGS = ${M32} -shared -export-dynamic
 	LCRYPT = -lcrypt
 	STRIP = strip
 else
 ifeq ($(shell uname), OpenBSD)
 	OS = OpenBSD
-	CFLAGS += -m32
-	PICOLISP-FLAGS = -m32 -rdynamic -Wl,-E
+	CFLAGS += ${M32}
+	PICOLISP-FLAGS = ${M32} -rdynamic -Wl,-E
 	LIB-FLAGS = -lm
 	DYNAMIC-LIB-FLAGS = -Wl,-E -Wl,-shared
 	LCRYPT = -lcrypto
@@ -39,34 +42,34 @@
 	OS = FreeBSD
 	CC = gcc
 	CCLD = clang
-	CFLAGS += -m32
-	PICOLISP-FLAGS = -m32 -rdynamic
+	CFLAGS += ${M32}
+	PICOLISP-FLAGS = ${M32} -rdynamic
 	LIB-FLAGS = -lm
-	DYNAMIC-LIB-FLAGS = -m32 -shared -export-dynamic
+	DYNAMIC-LIB-FLAGS = ${M32} -shared -export-dynamic
 	LCRYPT = -lcrypt
 	STRIP = strip
 else
 ifeq ($(shell uname), NetBSD)
 	OS = NetBSD
-	CFLAGS += -m32
-	PICOLISP-FLAGS = -m32 -rdynamic
+	CFLAGS += ${M32}
+	PICOLISP-FLAGS = ${M32} -rdynamic
 	LIB-FLAGS = -lm
-	DYNAMIC-LIB-FLAGS = -m32 -shared -export-dynamic
+	DYNAMIC-LIB-FLAGS = ${M32} -shared -export-dynamic
 	LCRYPT = -lcrypto
 	STRIP = strip
 else
 ifeq ($(shell uname), Darwin)
 	OS = Darwin
-	CFLAGS += -m32
-	PICOLISP-FLAGS = -m32
+	CFLAGS += ${M32}
+	PICOLISP-FLAGS = ${M32}
 	LIB-FLAGS = -lc -lm -ldl
-	DYNAMIC-LIB-FLAGS = -m32 -dynamiclib -undefined dynamic_lookup
+	DYNAMIC-LIB-FLAGS = ${M32} -dynamiclib -undefined dynamic_lookup
 	LCRYPT = -lcrypto
 	STRIP = strip -x
 else
 ifeq ($(shell uname), SunOS)
 	OS = SunOS
-	CFLAGS += -m32
+	CFLAGS += ${M32}
 	PICOLISP-FLAGS =
 	LIB-FLAGS = -lm -lnsl -lsocket
 	DYNAMIC-LIB-FLAGS = -G
@@ -85,21 +88,21 @@
 ifeq ($(shell uname), HP-UX)
 	OS = HP-UX
 	CFLAGS +=
-	PICOLISP-FLAGS = -m32 -rdynamic
+	PICOLISP-FLAGS = ${M32} -rdynamic
 	LIB-FLAGS = -lm -ldl
-	DYNAMIC-LIB-FLAGS = -m32 -shared
+	DYNAMIC-LIB-FLAGS = ${M32} -shared
 	LCRYPT =
 	STRIP = strip
 else
 ifeq ($(shell uname), IRIX64)
-    OS = IRIX64
-    CFLAGS += -std=gnu99
-    DYNAMIC-LIB-FLAGS = -shared
-    STRIP = strip -f
+	OS = IRIX64
+	CFLAGS += -std=gnu99
+	DYNAMIC-LIB-FLAGS = -shared
+	STRIP = strip -f
 else
-ifeq ($(shell uname -o), Cygwin)
+ifeq ($(shell uname -o | egrep -q "Cygwin|Msys" ; echo $$?), 0)
 	OS = Cygwin
-	CFLAGS += -m32
+	CFLAGS += ${M32}
 	DYNAMIC-LIB-FLAGS = -shared
 	PICOLISP-FLAGS =
 	DLL-DEFS = $(bin)/picolisp.dll
@@ -128,6 +131,8 @@
 .c.o:
 	$(CC) $(CFLAGS) -D_OS='"$(OS)"' $*.c
 
+ext.o ht.o: pico.h
+	$(CC) $(CFLAGS) -D_OS='"$(OS)"' $*.c $(DYNAMIC-CC-FLAGS)
 
 $(picoFiles:.c=.o) ext.o ht.o: pico.h
 main.o: vers.h

=== debian/changelog ===
picolisp (17.12+20180218-1) unstable; urgency=medium

  * New upstream version 17.12+20180218
    - Fixed relocation error in ext.l and ht.l. (Closes: 889911)
  * Refresh patches

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Sun, 18 Feb 2018 09:19:35 +0900

picolisp (17.12-2) unstable; urgency=medium

  * Fix bash_completion

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Wed, 17 Jan 2018 09:34:56 +0900

picolisp (17.12-1) unstable; urgency=medium

  * New upstream version 17.12
    (Closes: #857277)
  * debian/control: Update Vcs-{Git,Browser} to Salsa
  * debian/rules: Don't set DEB_HOST_ARCH_* variables
  * debian/rules: Remove unused get-orig-source target
  * Refresh patches
  * Bump Standards-Version to 4.1.3
  * Bump debhelper compat level to 11
  * Support arm64 build (Closes: #871515)

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Sun, 07 Jan 2018 14:14:11 +0900

=== debian/rules ===
--- 
+++ 
@@ -2,8 +2,6 @@
 # -*- makefile -*-
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
-DEB_HOST_ARCH_CPU := $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)
-DEB_HOST_ARCH_OS  := $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
 
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all
 DPKG_EXPORT_BUILDFLAGS = 1
@@ -36,6 +34,11 @@
 	make -C src OS=Linux tools gate
 
 	make -C src64 OS=Linux CFLAGS="$(CFLAGS_NO_PIE)" LDFLAGS="$(LDFLAGS_NO_PIE)" x86-64.linux picolisp
+else ifeq (arm64,$(DEB_HOST_ARCH_CPU))
+	mv src64/tags src64/tags.orig
+	make -C src OS=Linux tools gate
+
+	make -C src64 CFLAGS="$(CFLAGS_NO_PIE)" LDFLAGS="$(LDFLAGS_NO_PIE)" arm64.linux picolisp
 else ifeq (ppc64el,$(DEB_HOST_ARCH_CPU))
 	mv src64/tags src64/tags.orig
 	make -C src OS=Linux tools gate
@@ -83,14 +86,4 @@
 	dh_strip --no-automatic-dbgsym
 
 %:
-	dh $@ 
-
-VER?=3.0.7.1
-get-orig-source:
-	rm -rf picolisp-$(VER).orig
-	hg clone https://picolisp.googlecode.com/hg/#v$(VER) picolisp-$(VER).orig
-	rm -r picolisp-$(VER).orig/.hg picolisp-$(VER).orig/.hgtags
-	GZIP=--best tar -cz --owner root --group root --mode a+rX \
-			-f picolisp_$(VER).orig.tar.gz \
-			picolisp-$(VER).orig
-	rm -r picolisp-$(VER).orig
+	dh $@

## picolisp 18.6

=== debian/changelog ===
picolisp (18.6-1) unstable; urgency=medium

  * New upstream version 18.6
  * Bump Standards-Version to 4.1.4. No changes required

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Mon, 02 Jul 2018 08:39:10 +0900

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Kan-Ru Chen (陳侃如) <koster@debian.org>
 Build-Depends: debhelper (>= 11), dpkg-dev (>= 1.18.11~), libssl-dev, default-jdk
-Standards-Version: 4.1.3
+Standards-Version: 4.1.4
 Homepage: http://picolisp.com/
 Vcs-Git: https://salsa.debian.org/koster/picolisp.git
 Vcs-Browser: https://salsa.debian.org/koster/picolisp

## picolisp 18.12

=== debian/changelog ===
picolisp (18.12-1) unstable; urgency=medium

  * New upstream version 18.12
  * debian/rules: Build 64 bit binary with system picolisp
  * debian/control: Bump Standards-Version to 4.3.0. No changes required

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Thu, 03 Jan 2019 22:04:15 +0900

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,9 @@
 Section: lisp
 Priority: optional
 Maintainer: Kan-Ru Chen (陳侃如) <koster@debian.org>
-Build-Depends: debhelper (>= 11), dpkg-dev (>= 1.18.11~), libssl-dev, default-jdk
-Standards-Version: 4.1.4
+Build-Depends: debhelper (>= 11), dpkg-dev (>= 1.18.11~), libssl-dev,
+               picolisp [amd64 arm64 ppc64el]
+Standards-Version: 4.3.0
 Homepage: http://picolisp.com/
 Vcs-Git: https://salsa.debian.org/koster/picolisp.git
 Vcs-Browser: https://salsa.debian.org/koster/picolisp

=== debian/rules ===
--- 
+++ 
@@ -7,10 +7,10 @@
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
 
-ifeq (amd64,$(DEB_HOST_ARCH_CPU))
-# PIE disabled on amd64 because it's mostly written in assembly and
-# already handles PIC when needed. The codes aren't compiled with
-# gcc so enable -fPIE is meaningless.
+ifneq (,$(filter amd64 arm64 ppc64el,$(DEB_HOST_ARCH_CPU)))
+# PIE disabled on 64 bit architecture because it's mostly written in
+# assembly and already handles PIC when needed. The codes aren't
+# compiled with gcc so enable -fPIE is meaningless.
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie
 CFLAGS_NO_PIE := $(shell dpkg-buildflags --get CFLAGS)
 LDFLAGS_NO_PIE := $(shell dpkg-buildflags --get LDFLAGS)
@@ -23,11 +23,6 @@
 endif
 
 override_dh_auto_build:
-
-	chmod -x app/loc/no
-
-	mv java/reflector.jar java/reflector.jar.orig
-	(cd java/; ./mkJar)
 
 ifeq (amd64,$(DEB_HOST_ARCH_CPU))
 	mv src64/tags src64/tags.orig
@@ -50,7 +45,7 @@
 	mkdir -p build/bash_completion.d
 	cp lib/bash_completion build/bash_completion.d/pil
 
-#       build time utilities
+# Remove build time utilities
 	-rm src64/sysdeps
 
 override_dh_auto_test:
@@ -61,7 +56,6 @@
 	dh_install build/bash_completion.d/pil usr/share/bash-completion/completions
 	dh_install -X.o src   usr/share/picolisp
 	dh_install -X.o src64 usr/share/picolisp
-	dh_install -X.orig java usr/share/picolisp
 
 override_dh_installdocs:
 	dh_installdocs -Xdoc/db -Xdoc/utf8
@@ -76,7 +70,6 @@
 	-rm bin/ssl bin/httpGate bin/lat1 bin/utf2 bin/balance
 	-mv src64/tags.orig src64/tags
 	-rm -rf build
-	-mv java/reflector.jar.orig java/reflector.jar
 
 override_dh_compress:

## picolisp 19.6

=== debian/changelog ===
picolisp (19.6-2) unstable; urgency=medium

  * Install missed file /usr/lib/picolisp/lib/vip/draw.l
  * Switch dh compat to 12

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Mon, 08 Jul 2019 00:56:46 +0900

picolisp (19.6-1) unstable; urgency=medium

  * New upstream version 19.6
  * Refresh patches
  * debian/50picolisp.el: Don't override picolisp-mode defined variables
  * debian/50picolisp.el: Add autoload for picolisp-wiki-mode.
    Thanks to Jean-Christophe Helary for the suggestion

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Sun, 07 Jul 2019 12:31:26 +0900

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: lisp
 Priority: optional
 Maintainer: Kan-Ru Chen (陳侃如) <koster@debian.org>
-Build-Depends: debhelper (>= 11), dpkg-dev (>= 1.18.11~), libssl-dev,
+Build-Depends: debhelper (>= 12), dpkg-dev (>= 1.18.11~), libssl-dev,
                picolisp [amd64 arm64 ppc64el]
 Standards-Version: 4.3.0
 Homepage: http://picolisp.com/

## picolisp 19.12

=== src/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# 04oct17abu
+# 30jan19abu
 # (c) Software Lab. Alexander Burger
 
 bin = ../bin
@@ -42,10 +42,10 @@
 	OS = FreeBSD
 	CC = gcc
 	CCLD = clang
-	CFLAGS += ${M32}
+	CFLAGS += ${M32} -fPIC
 	PICOLISP-FLAGS = ${M32} -rdynamic
 	LIB-FLAGS = -lm
-	DYNAMIC-LIB-FLAGS = ${M32} -shared -export-dynamic
+	DYNAMIC-LIB-FLAGS = ${M32} -shared
 	LCRYPT = -lcrypt
 	STRIP = strip
 else

=== debian/changelog ===
picolisp (19.12-1) unstable; urgency=medium

  * New upstream version 19.12
  * debian/control: Bump Standards-Versoin to 4.4.1, no changes required

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Thu, 02 Jan 2020 21:07:25 +0900

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Kan-Ru Chen (陳侃如) <koster@debian.org>
 Build-Depends: debhelper (>= 12), dpkg-dev (>= 1.18.11~), libssl-dev,
                picolisp [amd64 arm64 ppc64el]
-Standards-Version: 4.3.0
+Standards-Version: 4.4.1
 Homepage: http://picolisp.com/
 Vcs-Git: https://salsa.debian.org/koster/picolisp.git
 Vcs-Browser: https://salsa.debian.org/koster/picolisp

=== debian/rules ===
--- 
+++ 
@@ -78,5 +78,7 @@
 override_dh_strip:
 	dh_strip --no-automatic-dbgsym
 
+override_dh_dwz: ;
+
 %:
 	dh $@

## picolisp 20.6

=== src64/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# 31oct17abu
+# 27apr20abu
 # (c) Software Lab. Alexander Burger
 
 bin = ../bin
@@ -28,15 +28,20 @@
 						UNAME = OpenBSD
 						MACHINE = x86_64
 					else
-						ifeq ($(MAKECMDGOALS), x86-64.sunOs)
-							UNAME = SunOS
-							MACHINE = x86_64
-						else
-							UNAME = $(shell uname)
-							ifeq ($(MAKECMDGOALS), emu)
-								MACHINE = emu
+					ifeq ($(MAKECMDGOALS), arm64.openBsd)
+						UNAME = OpenBSD
+						MACHINE = aarch64
 							else
-								MACHINE = $(shell uname -m)
+							ifeq ($(MAKECMDGOALS), x86-64.sunOs)
+								UNAME = SunOS
+								MACHINE = x86_64
+							else
+								UNAME = $(shell uname)
+								ifeq ($(MAKECMDGOALS), emu)
+									MACHINE = emu
+								else
+									MACHINE = $(shell uname -m)
+								endif
 							endif
 						endif
 					endif
@@ -104,11 +109,18 @@
 				OS = OpenBSD
 				SYS = .openBsd
 				FMT = .s
-				ARCH = x86-64
-				AS = as
 				LD-MAIN = -Wl,-nopie -rdynamic -lc -lm
 				LD-SHARED = -shared -rdynamic
 				STRIP = strip
+				ifeq ($(MACHINE), aarch64)
+					ARCH = arm64
+					AS = gas
+					CC = clang
+				else
+					ARCH = x86-64
+					AS = as
+					CC = clang
+				endif
 			else
 				ifeq ($(UNAME), SunOS)
 					OS = SunOS
@@ -137,6 +149,7 @@
 
 arm64.android: $(sFiles)
 arm64.linux: $(sFiles)
+arm64.openBsd: $(sFiles)
 x86-64.linux: $(sFiles)
 ppc64.linux: $(sFiles)
 x86-64.freeBsd: $(sFiles)
@@ -187,5 +200,3 @@
 ### Clean up ###
 clean:
 	rm -f emu.*.c *.s *.o *.symtab sysdefs
-
-# vi:noet:ts=4:sw=4

=== debian/changelog ===
picolisp (20.6-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Use secure URI in debian/watch.

  [ Kan-Ru Chen ]
  * New upstream version 20.6

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Tue, 30 Jun 2020 00:04:08 +0900

## picolisp 21.1.8

=== src/Makefile ===
# 24dec20 Software Lab. Alexander Burger

.SILENT:

CC = clang
PIL = ../pil  # pil
ASM = opt -O3  # llvm-as
MAIN = -rdynamic -lc -lm -ldl -lreadline -lffi
SHARED = -shared
OS = $(shell uname)
CPU = $(shell uname -m)

BIN = ../bin
LIB = ../lib

INC = lib/llvm.l vers.l defs.l glob.l dec.l
SRC = main.l gc.l big.l sym.l io.l db.l apply.l flow.l subr.l

all: $(LIB)/sysdefs $(BIN)/picolisp $(LIB)/ext.so $(LIB)/ht.so $(BIN)/balance $(BIN)/ssl $(BIN)/httpGate

# System definitions
$(LIB)/sysdefs: sysdefs.c
	$(CC) -w -D_OS='"$(OS)"' -D_CPU='"$(CPU)"' sysdefs.c  &&  ./a.out > $(LIB)/sysdefs  &&  rm ./a.out

# Base system
$(BIN)/picolisp: picolisp.bc
	mkdir -p $(BIN) $(LIB)
	llc picolisp.bc -relocation-model=pic -o picolisp.s
	$(CC) picolisp.s -o $(BIN)/picolisp $(MAIN)

picolisp.bc: base.bc lib.bc
	llvm-link -o picolisp.bc base.bc lib.bc

base.bc: base.ll
	$(ASM) -o base.bc base.ll

base.ll: $(INC) $(SRC)
	$(PIL) lib/llvm.l main.l -bye > base.ll
	mv base.map $(LIB)/map

lib.bc: pico.h lib.c
	$(CC) -O3 -w -c -D_OS='"$(OS)"' -D_CPU='"$(CPU)"' `pkg-config --cflags libffi` -emit-llvm lib.c

# Extension libraries
$(LIB)/ext.so: ext.bc
	llc ext.bc -relocation-model=pic -o ext.s
	$(CC) ext.s -o $(LIB)/ext.so $(SHARED)

ext.bc: ext.ll
	$(ASM) -o ext.bc ext.ll

ext.ll: $(INC) ext.l
	$(PIL) lib/llvm.l ext.l -bye > ext.ll

$(LIB)/ht.so: ht.bc
	llc ht.bc -relocation-model=pic -o ht.s
	$(CC) ht.s -o $(LIB)/ht.so $(SHARED)

ht.bc: ht.ll
	$(ASM) -o ht.bc ht.ll

ht.ll: $(INC) ht.l
	$(PIL) lib/llvm.l ht.l -bye > ht.ll

# Tools
$(BIN)/balance: balance.c
	$(CC) -O3 -w -o $(BIN)/balance balance.c

# Gate
$(BIN)/ssl: ssl.c
	$(CC) -O3 -w -o $(BIN)/ssl ssl.c -lssl -lcrypto

$(BIN)/httpGate: httpGate.c
	$(CC) -O3 -w -o $(BIN)/httpGate httpGate.c -lssl -lcrypto

# Clean up
clean:
	rm -f *.ll *.bc *.s

=== debian/changelog ===
picolisp (21.1.8-1) unstable; urgency=medium

  * New upstream version 21.1.8
    - Fixes build pil64 with pil21 (Closes: #978336)
  * debian/rules: install bash_completion file
  * debian/NEWS: mention how to use lib/compat.l

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Sat, 09 Jan 2021 09:33:36 +0900

picolisp (21.0.0+20201226-3) unstable; urgency=medium

  * debian/picolisp.links: Link usr/lib/picolisp/doc to usr/share/doc/picolisp/doc
  * debian/copyright: Update the binary license of balance, httpGate, and ssl

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Sun, 03 Jan 2021 22:10:06 +0900

picolisp (21.0.0+20201226-2) unstable; urgency=medium

  * Move nobootstrap option handling into override_dh_auto_build
  * debian/control: specify supported 64-bit architectures

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Sun, 27 Dec 2020 08:32:13 +0900

picolisp (21.0.0+20201226-1) unstable; urgency=medium

  * New upstream version 21.0.0
  * Refresh patches
  * Support nobootstrap build option for building on new architecture
  * debian/50picolisp.el is unshipped

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Sat, 26 Dec 2020 18:45:13 +0900

=== debian/control ===
--- 
+++ 
@@ -3,15 +3,14 @@
 Priority: optional
 Maintainer: Kan-Ru Chen (陳侃如) <koster@debian.org>
 Build-Depends: debhelper (>= 12), dpkg-dev (>= 1.18.11~), libssl-dev,
-               picolisp [amd64 arm64 ppc64el]
-Standards-Version: 4.4.1
+ libreadline-dev, libffi-dev, pkg-config, clang, llvm, picolisp
+Standards-Version: 4.5.1
 Homepage: http://picolisp.com/
 Vcs-Git: https://salsa.debian.org/koster/picolisp.git
 Vcs-Browser: https://salsa.debian.org/koster/picolisp
 
-# Only supports amd64 on linux and solaris
 Package: picolisp
-Architecture: any
+Architecture: amd64 arm64 mips64el ppc64el s390x
 Pre-Depends: dpkg (>= 1.17.5)
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Suggests: tinymce

## picolisp 21.12

=== src/Makefile ===
--- 
+++ 
@@ -1,12 +1,16 @@
-# 24dec20 Software Lab. Alexander Burger
+# 19aug21 Software Lab. Alexander Burger
 
 .SILENT:
 
 CC = clang
 PIL = ../pil  # pil
 ASM = opt -O3  # llvm-as
-MAIN = -rdynamic -lc -lm -ldl -lreadline -lffi
+LLC = llc
+LINK = llvm-link
+MAIN = -rdynamic -lc -lutil -lm -ldl -lreadline -lffi
 SHARED = -shared
+STRIP = strip
+
 OS = $(shell uname)
 CPU = $(shell uname -m)
 
@@ -25,11 +29,12 @@
 # Base system
 $(BIN)/picolisp: picolisp.bc
 	mkdir -p $(BIN) $(LIB)
-	llc picolisp.bc -relocation-model=pic -o picolisp.s
+	$(LLC) picolisp.bc -relocation-model=pic -o picolisp.s
 	$(CC) picolisp.s -o $(BIN)/picolisp $(MAIN)
+	$(STRIP) $(BIN)/picolisp
 
 picolisp.bc: base.bc lib.bc
-	llvm-link -o picolisp.bc base.bc lib.bc
+	$(LINK) -o picolisp.bc base.bc lib.bc
 
 base.bc: base.ll
 	$(ASM) -o base.bc base.ll
@@ -43,8 +48,9 @@
 
 # Extension libraries
 $(LIB)/ext.so: ext.bc
-	llc ext.bc -relocation-model=pic -o ext.s
+	$(LLC) ext.bc -relocation-model=pic -o ext.s
 	$(CC) ext.s -o $(LIB)/ext.so $(SHARED)
+	$(STRIP) $(LIB)/ext.so
 
 ext.bc: ext.ll
 	$(ASM) -o ext.bc ext.ll
@@ -53,8 +59,9 @@
 	$(PIL) lib/llvm.l ext.l -bye > ext.ll
 
 $(LIB)/ht.so: ht.bc
-	llc ht.bc -relocation-model=pic -o ht.s
+	$(LLC) ht.bc -relocation-model=pic -o ht.s
 	$(CC) ht.s -o $(LIB)/ht.so $(SHARED)
+	$(STRIP) $(LIB)/ht.so
 
 ht.bc: ht.ll
 	$(ASM) -o ht.bc ht.ll
@@ -65,13 +72,16 @@
 # Tools
 $(BIN)/balance: balance.c
 	$(CC) -O3 -w -o $(BIN)/balance balance.c
+	$(STRIP) $(BIN)/balance
 
 # Gate
 $(BIN)/ssl: ssl.c
 	$(CC) -O3 -w -o $(BIN)/ssl ssl.c -lssl -lcrypto
+	$(STRIP) $(BIN)/ssl
 
 $(BIN)/httpGate: httpGate.c
 	$(CC) -O3 -w -o $(BIN)/httpGate httpGate.c -lssl -lcrypto
+	$(STRIP) $(BIN)/httpGate
 
 # Clean up
 clean:

=== debian/changelog ===
picolisp (21.12-2) unstable; urgency=medium

  * debian/patches: Apply a database bug fix patch from upstream

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Tue, 04 Jan 2022 20:03:47 +0900

picolisp (21.12-1) unstable; urgency=medium

  * New upstream version 21.12
  * Update lintian-overrides
  * debian/control: bump Standards-Version to 4.6.0, no changes needed.
  * debian/control: add w3m to suggests as the default doc viewer

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Mon, 27 Dec 2021 23:45:21 +0900

picolisp (21.6-2) unstable; urgency=medium

  * Upload to unstable.

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Sun, 15 Aug 2021 23:03:04 +0900

picolisp (21.6-1) experimental; urgency=medium

  * New upstream version 21.6

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Sun, 15 Aug 2021 23:02:30 +0900

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Kan-Ru Chen (陳侃如) <koster@debian.org>
 Build-Depends: debhelper (>= 12), dpkg-dev (>= 1.18.11~), libssl-dev,
  libreadline-dev, libffi-dev, pkg-config, clang, llvm, picolisp
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Homepage: http://picolisp.com/
 Vcs-Git: https://salsa.debian.org/koster/picolisp.git
 Vcs-Browser: https://salsa.debian.org/koster/picolisp
@@ -13,7 +13,7 @@
 Architecture: amd64 arm64 mips64el ppc64el s390x
 Pre-Depends: dpkg (>= 1.17.5)
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Suggests: tinymce
+Suggests: tinymce, w3m
 Description: Lisp interpreter and application server framework
  Pico Lisp can be viewed from two different aspects: As a general
  purpose programming language, and a dedicated application server

## picolisp 22.6

=== src/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# 19aug21 Software Lab. Alexander Burger
+# 08apr22 Software Lab. Alexander Burger
 
 .SILENT:
 
@@ -44,7 +44,7 @@
 	mv base.map $(LIB)/map
 
 lib.bc: pico.h lib.c
-	$(CC) -O3 -w -c -D_OS='"$(OS)"' -D_CPU='"$(CPU)"' `pkg-config --cflags libffi` -emit-llvm lib.c
+	$(CC) -O3 -w -c -o lib.bc -D_OS='"$(OS)"' -D_CPU='"$(CPU)"' `pkg-config --cflags libffi` -emit-llvm lib.c
 
 # Extension libraries
 $(LIB)/ext.so: ext.bc
@@ -86,3 +86,6 @@
 # Clean up
 clean:
 	rm -f *.ll *.bc *.s
+
+clean2: clean
+	rm -f $(BIN)/balance $(BIN)/ssl $(BIN)/httpGate

=== debian/changelog ===
picolisp (22.6-1) unstable; urgency=medium

  [ Kan-Ru Chen ]
  * New upstream version 22.6

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Sat, 02 Jul 2022 22:42:40 +0900

picolisp (22.3-1) unstable; urgency=medium

  * New upstream version 22.3
  * Refresh patches

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Mon, 21 Mar 2022 17:00:03 +0900
